#ifndef LCDi2cW_h
#define LCDi2cW_h


#define _LCDEXPANDED				// If defined turn on advanced functions

#include <inttypes.h>

#include "Print.h"


class LCDi2cW : public Print {
	
public: 
	
LCDi2cW(uint8_t num_lines, uint8_t num_col, int i2c_address, uint8_t display);
	
	size_t command(uint8_t value);
	
	size_t init();
	
	size_t setDelay(int,int);
	
	virtual size_t write(uint8_t);
	
	size_t clear();
	
	size_t home();
	
	size_t on();
	
	size_t off();
	
	size_t cursor_on();
	
	size_t cursor_off();
	
	size_t blink_on();
	
	size_t blink_off();
	
	size_t setCursor(uint8_t Line, uint8_t Col );
	
	
	// [][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
	// []
	// []	Extended Functions
	// []
	// [][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
	
	
#ifdef _LCDEXPANDED		

	
	uint8_t status();
	
	size_t load_custom_character(uint8_t char_num, uint8_t *rows);
	
	uint8_t keypad();
	
	size_t printstr(const char[]);
	
	 // Values for graphtype in calls to init_bargraph
	
	 #define LCDI2C_VERTICAL_BAR_GRAPH    1
	 #define LCDI2C_HORIZONTAL_BAR_GRAPH  2
	 #define LCDI2C_HORIZONTAL_LINE_GRAPH 3
	 
	 uint8_t init_bargraph(uint8_t graphtype);
	
	 size_t draw_horizontal_graph(uint8_t row, uint8_t column, uint8_t len,  uint8_t pixel_col_end);
	
	 size_t draw_vertical_graph(uint8_t row, uint8_t column, uint8_t len,  uint8_t pixel_col_end);
	 
	 size_t setBacklight(uint8_t new_val);
	
	 size_t setContrast(uint8_t new_val);
	 
		
#endif
	
private:
	
	
};

#endif

